Index: kernel/arch/amd64/include/mm/as.h
===================================================================
--- kernel/arch/amd64/include/mm/as.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ kernel/arch/amd64/include/mm/as.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -36,11 +36,14 @@
 #define KERN_amd64_AS_H_
 
+#define ADDRESS_SPACE_HOLE_START	0x0000800000000000ULL
+#define ADDRESS_SPACE_HOLE_END		0xffff7fffffffffffULL
+
 #define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  0
 
-#define KERNEL_ADDRESS_SPACE_START_ARCH  (unsigned long) 0xffff800000000000
-#define KERNEL_ADDRESS_SPACE_END_ARCH    (unsigned long) 0xffffffffffffffff
+#define KERNEL_ADDRESS_SPACE_START_ARCH	0xffff800000000000ULL
+#define KERNEL_ADDRESS_SPACE_END_ARCH	0xffffffffffffffffULL
 
-#define USER_ADDRESS_SPACE_START_ARCH    (unsigned long) 0x0000000000000000
-#define USER_ADDRESS_SPACE_END_ARCH      (unsigned long) 0x00007fffffffffff
+#define USER_ADDRESS_SPACE_START_ARCH	0x0000000000000000ULL
+#define USER_ADDRESS_SPACE_END_ARCH	0x00007fffffffffffULL
 
 #define USTACK_ADDRESS_ARCH  (USER_ADDRESS_SPACE_END_ARCH - (PAGE_SIZE - 1))
Index: kernel/arch/amd64/include/pm.h
===================================================================
--- kernel/arch/amd64/include/pm.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ kernel/arch/amd64/include/pm.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -83,5 +83,5 @@
 
 #define TSS_BASIC_SIZE  104
-#define TSS_IOMAP_SIZE  (16 * 1024 + 1)  /* 16K for bitmap + 1 terminating byte for convenience */
+#define TSS_IOMAP_SIZE  (8 * 1024 + 1)  /* 8K for bitmap + 1 terminating byte for convenience */
 
 #define IO_PORTS  (64 * 1024)
Index: kernel/arch/amd64/src/ddi/ddi.c
===================================================================
--- kernel/arch/amd64/src/ddi/ddi.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ kernel/arch/amd64/src/ddi/ddi.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -126,11 +126,16 @@
 		bitmap_initialize(&iomap, CPU->arch.tss->iomap,
 		    TSS_IOMAP_SIZE * 8);
-		bitmap_copy(&iomap, &TASK->arch.iomap, TASK->arch.iomap.bits);
+		bitmap_copy(&iomap, &TASK->arch.iomap, bits);
 		
+		/*
+		 * Set the trailing bits in the last byte of the map to disable
+		 * I/O access.
+		 */
+		bitmap_set_range(&iomap, bits, ALIGN_UP(bits, 8) - bits);
 		/*
 		 * It is safe to set the trailing eight bits because of the
 		 * extra convenience byte in TSS_IOMAP_SIZE.
 		 */
-		bitmap_set_range(&iomap, ALIGN_UP(TASK->arch.iomap.bits, 8), 8);
+		bitmap_set_range(&iomap, ALIGN_UP(bits, 8), 8);
 	}
 	irq_spinlock_unlock(&TASK->lock, false);
Index: kernel/arch/ia32/include/pm.h
===================================================================
--- kernel/arch/ia32/include/pm.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ kernel/arch/ia32/include/pm.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -75,5 +75,5 @@
 
 #define TSS_BASIC_SIZE  104
-#define TSS_IOMAP_SIZE  (16 * 1024 + 1)  /* 16K for bitmap + 1 terminating byte for convenience */
+#define TSS_IOMAP_SIZE  (8 * 1024 + 1)  /* 8K for bitmap + 1 terminating byte for convenience */
 
 #define IO_PORTS  (64 * 1024)
Index: kernel/arch/ia32/src/ddi/ddi.c
===================================================================
--- kernel/arch/ia32/src/ddi/ddi.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ kernel/arch/ia32/src/ddi/ddi.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -127,11 +127,16 @@
 		bitmap_initialize(&iomap, CPU->arch.tss->iomap,
 		    TSS_IOMAP_SIZE * 8);
-		bitmap_copy(&iomap, &TASK->arch.iomap, TASK->arch.iomap.bits);
+		bitmap_copy(&iomap, &TASK->arch.iomap, bits);
 		
+		/*
+		 * Set the trailing bits in the last byte of the map to disable
+		 * I/O access.
+		 */
+		bitmap_set_range(&iomap, bits, ALIGN_UP(bits, 8) - bits);
 		/*
 		 * It is safe to set the trailing eight bits because of the
 		 * extra convenience byte in TSS_IOMAP_SIZE.
 		 */
-		bitmap_set_range(&iomap, ALIGN_UP(TASK->arch.iomap.bits, 8), 8);
+		bitmap_set_range(&iomap, ALIGN_UP(bits, 8), 8);
 	}
 	irq_spinlock_unlock(&TASK->lock, false);
Index: kernel/generic/include/typedefs.h
===================================================================
--- kernel/generic/include/typedefs.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ kernel/generic/include/typedefs.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -40,5 +40,5 @@
 #include <arch/types.h>
 
-#define NULL  0
+#define NULL  0UL
 
 #define false  0
Index: kernel/generic/src/adt/bitmap.c
===================================================================
--- kernel/generic/src/adt/bitmap.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ kernel/generic/src/adt/bitmap.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -32,5 +32,5 @@
 /**
  * @file
- * @brief	Implementation of bitmap ADT.
+ * @brief Implementation of bitmap ADT.
  *
  * This file implements bitmap ADT and provides functions for
@@ -51,7 +51,7 @@
  * No portion of the bitmap is set or cleared by this function.
  *
- * @param bitmap Bitmap structure.
- * @param map Address of the memory used to hold the map.
- * @param bits Number of bits stored in bitmap.
+ * @param bitmap	Bitmap structure.
+ * @param map		Address of the memory used to hold the map.
+ * @param bits		Number of bits stored in bitmap.
  */
 void bitmap_initialize(bitmap_t *bitmap, uint8_t *map, size_t bits)
@@ -63,7 +63,7 @@
 /** Set range of bits.
  *
- * @param bitmap Bitmap structure.
- * @param start Starting bit.
- * @param bits Number of bits to set.
+ * @param bitmap	Bitmap structure.
+ * @param start		Starting bit.
+ * @param bits		Number of bits to set.
  */
 void bitmap_set_range(bitmap_t *bitmap, size_t start, size_t bits)
@@ -71,7 +71,7 @@
 	size_t i = 0;
 	size_t aligned_start;
-	size_t lub;		/* leading unaligned bits */
-	size_t amb;		/* aligned middle bits */
-	size_t tab;		/* trailing aligned bits */
+	size_t lub;	/* leading unaligned bits */
+	size_t amb;	/* aligned middle bits */
+	size_t tab;	/* trailing aligned bits */
 	
 	ASSERT(start + bits <= bitmap->bits);
@@ -82,28 +82,23 @@
 	tab = amb % 8;
 	
-	if ( start + bits < aligned_start ) {
-	    /*
-	    * Set bits in the middle of byte
-	    */
-	    bitmap->map[start / 8] |= ((1 << lub)-1) << (start&7);
-	    return;
+	if (!bits)
+		return;
+
+	if (start + bits < aligned_start) {
+		/* Set bits in the middle of byte. */
+		bitmap->map[start / 8] |= ((1 << lub) - 1) << (start & 7);
+		return;
 	}
 	
 	if (lub) {
-		/*
-		 * Make sure to set any leading unaligned bits.
-		 */
+		/* Make sure to set any leading unaligned bits. */
 		bitmap->map[start / 8] |= ~((1 << (8 - lub)) - 1);
 	}
 	for (i = 0; i < amb / 8; i++) {
-		/*
-		 * The middle bits can be set byte by byte.
-		 */
+		/* The middle bits can be set byte by byte. */
 		bitmap->map[aligned_start / 8 + i] = ALL_ONES;
 	}
 	if (tab) {
-		/*
-		 * Make sure to set any trailing aligned bits.
-		 */
+		/* Make sure to set any trailing aligned bits. */
 		bitmap->map[aligned_start / 8 + i] |= (1 << tab) - 1;
 	}
@@ -113,7 +108,7 @@
 /** Clear range of bits.
  *
- * @param bitmap Bitmap structure.
- * @param start Starting bit.
- * @param bits Number of bits to clear.
+ * @param bitmap	Bitmap structure.
+ * @param start		Starting bit.
+ * @param bits		Number of bits to clear.
  */
 void bitmap_clear_range(bitmap_t *bitmap, size_t start, size_t bits)
@@ -121,7 +116,7 @@
 	size_t i = 0;
 	size_t aligned_start;
-	size_t lub;		/* leading unaligned bits */
-	size_t amb;		/* aligned middle bits */
-	size_t tab;		/* trailing aligned bits */
+	size_t lub;	/* leading unaligned bits */
+	size_t amb;	/* aligned middle bits */
+	size_t tab;	/* trailing aligned bits */
 	
 	ASSERT(start + bits <= bitmap->bits);
@@ -132,30 +127,23 @@
 	tab = amb % 8;
 
-	if ( start + bits < aligned_start )
-	{
-	    /*
-	    * Set bits in the middle of byte
-	    */
-	    bitmap->map[start / 8] &= ~(((1 << lub)-1) << (start&7));
-	    return;
+	if (!bits)
+		return;
+
+	if (start + bits < aligned_start) {
+		/* Set bits in the middle of byte */
+		bitmap->map[start / 8] &= ~(((1 << lub) - 1) << (start & 7));
+		return;
 	}
 
-
 	if (lub) {
-		/*
-		 * Make sure to clear any leading unaligned bits.
-		 */
+		/* Make sure to clear any leading unaligned bits. */
 		bitmap->map[start / 8] &= (1 << (8 - lub)) - 1;
 	}
 	for (i = 0; i < amb / 8; i++) {
-		/*
-		 * The middle bits can be cleared byte by byte.
-		 */
+		/* The middle bits can be cleared byte by byte. */
 		bitmap->map[aligned_start / 8 + i] = ALL_ZEROES;
 	}
 	if (tab) {
-		/*
-		 * Make sure to clear any trailing aligned bits.
-		 */
+		/* Make sure to clear any trailing aligned bits. */
 		bitmap->map[aligned_start / 8 + i] &= ~((1 << tab) - 1);
 	}
@@ -165,7 +153,7 @@
 /** Copy portion of one bitmap into another bitmap.
  *
- * @param dst Destination bitmap.
- * @param src Source bitmap.
- * @param bits Number of bits to copy.
+ * @param dst		Destination bitmap.
+ * @param src		Source bitmap.
+ * @param bits		Number of bits to copy.
  */
 void bitmap_copy(bitmap_t *dst, bitmap_t *src, size_t bits)
Index: kernel/generic/src/syscall/copy.c
===================================================================
--- kernel/generic/src/syscall/copy.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ kernel/generic/src/syscall/copy.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -68,5 +68,6 @@
 	if (!KERNEL_ADDRESS_SPACE_SHADOWED) {
 		if (overlaps((uintptr_t) uspace_src, size,
-			KERNEL_ADDRESS_SPACE_START, KERNEL_ADDRESS_SPACE_END-KERNEL_ADDRESS_SPACE_START)) {
+			KERNEL_ADDRESS_SPACE_START,
+			KERNEL_ADDRESS_SPACE_END - KERNEL_ADDRESS_SPACE_START)) {
 			/*
 			 * The userspace source block conflicts with kernel address space.
@@ -75,4 +76,13 @@
 		}
 	}
+
+#ifdef ADDRESS_SPACE_HOLE_START
+	/*
+	 * Check whether the address is outside the address space hole.
+	 */
+	if (overlaps((uintptr_t) uspace_src, size, ADDRESS_SPACE_HOLE_START,
+	    ADDRESS_SPACE_HOLE_END - ADDRESS_SPACE_HOLE_START))
+		return EPERM;
+#endif
 	
 	ipl = interrupts_disable();
@@ -109,5 +119,6 @@
 	if (!KERNEL_ADDRESS_SPACE_SHADOWED) {
 		if (overlaps((uintptr_t) uspace_dst, size,
-			KERNEL_ADDRESS_SPACE_START, KERNEL_ADDRESS_SPACE_END-KERNEL_ADDRESS_SPACE_START)) {
+			KERNEL_ADDRESS_SPACE_START,
+			KERNEL_ADDRESS_SPACE_END - KERNEL_ADDRESS_SPACE_START)) {
 			/*
 			 * The userspace destination block conflicts with kernel address space.
@@ -116,4 +127,13 @@
 		}
 	}
+
+#ifdef ADDRESS_SPACE_HOLE_START
+	/*
+	 * Check whether the address is outside the address space hole.
+	 */
+	if (overlaps((uintptr_t) uspace_dst, size, ADDRESS_SPACE_HOLE_START,
+	    ADDRESS_SPACE_HOLE_END - ADDRESS_SPACE_HOLE_START))
+		return EPERM;
+#endif
 	
 	ipl = interrupts_disable();
Index: tools/toolchain.sh
===================================================================
--- tools/toolchain.sh	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ tools/toolchain.sh	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -62,6 +62,7 @@
 	echo " ia32       IA-32 (x86, i386)"
 	echo " ia64       IA-64 (Itanium)"
-	echo " mips32     MIPS little-endian"
-	echo " mips32eb   MIPS big-endian"
+	echo " mips32     MIPS little-endian 32b"
+	echo " mips32eb   MIPS big-endian 32b"
+	echo " mips64     MIPS little-endian 64b"
 	echo " ppc32      32-bit PowerPC"
 	echo " ppc64      64-bit PowerPC"
@@ -303,4 +304,7 @@
 		build_target "mips32eb" "mips-linux-gnu"
 		;;
+	"mips64")
+		build_target "mips64" "mips64el-linux-gnu"
+		;;
 	"ppc32")
 		build_target "ppc32" "ppc-linux-gnu"
@@ -320,4 +324,5 @@
 		build_target "mips32" "mipsel-linux-gnu"
 		build_target "mips32eb" "mips-linux-gnu"
+		build_target "mips64" "mips64el-linux-gnu"
 		build_target "ppc32" "ppc-linux-gnu"
 		build_target "ppc64" "ppc64-linux-gnu"
Index: uspace/app/bdsh/cmds/modules/bdd/bdd.c
===================================================================
--- uspace/app/bdsh/cmds/modules/bdd/bdd.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/app/bdsh/cmds/modules/bdd/bdd.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -68,5 +68,5 @@
 	unsigned int argc;
 	unsigned int i, j;
-	dev_handle_t handle;
+	devmap_handle_t handle;
 	uint8_t *blk;
 	size_t size, bytes, rows;
Index: uspace/app/bdsh/cmds/modules/help/help.c
===================================================================
--- uspace/app/bdsh/cmds/modules/help/help.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/app/bdsh/cmds/modules/help/help.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -45,7 +45,8 @@
 extern const char *progname;
 
-#define HELP_IS_MODULE   1
-#define HELP_IS_BUILTIN  0
-#define HELP_IS_RUBBISH  -1
+#define HELP_IS_COMMANDS	2
+#define HELP_IS_MODULE		1
+#define HELP_IS_BUILTIN		0
+#define HELP_IS_RUBBISH 	-1
 
 volatile int mod_switch = -1;
@@ -55,4 +56,7 @@
 {
 	int rc = HELP_IS_RUBBISH;
+
+	if (str_cmp(cmd, "commands") == 0)
+		return HELP_IS_COMMANDS;
 
 	rc = is_builtin(cmd);
@@ -90,44 +94,11 @@
 }
 
-int cmd_help(char *argv[])
+static void help_commands(void)
 {
+	builtin_t *cmd;
 	module_t *mod;
-	builtin_t *cmd;
-	unsigned int i = 0;
-	int rc = 0;
-	int argc;
-	int level = HELP_SHORT;
+	unsigned int i;
 
-	argc = cli_count_args(argv);
-
-	if (argc > 3) {
-		printf("\nToo many arguments to `%s', try:\n", cmdname);
-		help_cmd_help(HELP_SHORT);
-		return CMD_FAILURE;
-	}
-
-	if (argc == 3) {
-		if (!str_cmp("extended", argv[2]))
-			level = HELP_LONG;
-		else
-			level = HELP_SHORT;
-	}
-
-	if (argc > 1) {
-		rc = is_mod_or_builtin(argv[1]);
-		switch (rc) {
-		case HELP_IS_RUBBISH:
-			printf("Invalid command %s\n", argv[1]);
-			return CMD_FAILURE;
-		case HELP_IS_MODULE:
-			help_module(mod_switch, level);
-			return CMD_SUCCESS;
-		case HELP_IS_BUILTIN:
-			help_builtin(mod_switch, level);
-			return CMD_SUCCESS;
-		}
-	}
-
-	printf("\n  Available commands are:\n");
+	printf("\n  Bdsh built-in commands:\n");
 	printf("  ------------------------------------------------------------\n");
 
@@ -154,4 +125,73 @@
 	printf("\n  Try %s %s for more information on how `%s' works.\n\n",
 		cmdname, cmdname, cmdname);
+}
+
+/** Display survival tips. ('help' without arguments) */
+static void help_survival(void)
+{
+	printf("Don't panic!\n\n");
+
+	printf("This is Bdsh, the Brain dead shell, currently "
+	    "the primary user interface to HelenOS. Bdsh allows you to enter "
+	    "commands and supports history (Up, Down arrow keys), "
+	    "line editing (Left Arrow, Right Arrow, Home, End, Backspace), "
+	    "selection (Shift + movement keys), copy and paste (Ctrl-C, "
+	    "Ctrl-V), similar to common desktop environments.\n\n");
+
+	printf("The most basic filesystem commands are Bdsh builtins. Type "
+	    "'help commands' [Enter] to see the list of Bdsh builtin commands. "
+	    "Other commands are external executables located in the /app and "
+	    "/srv directories. Type 'ls /app' [Enter] and 'ls /srv' [Enter] "
+	    "to see their list. You can execute an external command simply "
+	    "by entering its name (e.g. type 'tetris' [Enter]).\n\n");
+
+	printf("HelenOS has virtual consoles (VCs). You can switch between "
+	    "these using the F1-F11 keys.\n\n");
+
+	printf("This is but a small glimpse of what you can do with HelenOS. "
+	    "To learn more please point your browser to the HelenOS User's "
+	    "Guide: http://trac.helenos.org/trac.fcgi/wiki/UsersGuide\n\n");
+}
+
+int cmd_help(char *argv[])
+{
+	int rc = 0;
+	int argc;
+	int level = HELP_SHORT;
+
+	argc = cli_count_args(argv);
+
+	if (argc > 3) {
+		printf("\nToo many arguments to `%s', try:\n", cmdname);
+		help_cmd_help(HELP_SHORT);
+		return CMD_FAILURE;
+	}
+
+	if (argc == 3) {
+		if (!str_cmp("extended", argv[2]))
+			level = HELP_LONG;
+		else
+			level = HELP_SHORT;
+	}
+
+	if (argc > 1) {
+		rc = is_mod_or_builtin(argv[1]);
+		switch (rc) {
+		case HELP_IS_RUBBISH:
+			printf("Invalid topic %s\n", argv[1]);
+			return CMD_FAILURE;
+		case HELP_IS_COMMANDS:
+			help_commands();
+			return CMD_SUCCESS;
+		case HELP_IS_MODULE:
+			help_module(mod_switch, level);
+			return CMD_SUCCESS;
+		case HELP_IS_BUILTIN:
+			help_builtin(mod_switch, level);
+			return CMD_SUCCESS;
+		}
+	}
+
+	help_survival();
 
 	return CMD_SUCCESS;
Index: uspace/app/bdsh/scli.c
===================================================================
--- uspace/app/bdsh/scli.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/app/bdsh/scli.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -89,7 +89,4 @@
 		exit(EXIT_FAILURE);
 
-	printf("Welcome to %s - %s\nType `help' at any time for usage information.\n",
-		progname, PACKAGE_STRING);
-
 	while (!cli_quit) {
 		get_input(&usr);
Index: uspace/app/getterm/Makefile
===================================================================
--- uspace/app/getterm/Makefile	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/app/getterm/Makefile	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -34,5 +34,6 @@
 SOURCES = \
 	getterm.c \
-	version.c
+	version.c \
+	welcome.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/getterm/getterm.c
===================================================================
--- uspace/app/getterm/getterm.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/app/getterm/getterm.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -43,4 +43,5 @@
 #include <errno.h>
 #include "version.h"
+#include "welcome.h"
 
 #define APP_NAME  "getterm"
@@ -48,5 +49,5 @@
 static void usage(void)
 {
-	printf("Usage: %s <terminal> <path>\n", APP_NAME);
+	printf("Usage: %s <terminal> [-w] <command> [<arguments...>]\n", APP_NAME);
 }
 
@@ -73,29 +74,41 @@
 }
 
-static task_id_t spawn(const char *fname)
-{
-	task_id_t id;
-	int rc;
-	
-	rc = task_spawnl(&id, fname, fname, NULL);
-	if (rc != EOK) {
-		printf("%s: Error spawning %s (%s)\n", APP_NAME, fname,
-		    str_error(rc));
-		return 0;
-	}
-	
-	return id;
-}
-
 int main(int argc, char *argv[])
 {
-	if (argc < 3) {
+	int rc;
+	task_exit_t texit;
+	int retval;
+	task_id_t id;
+	char *fname, *term;
+	char **cmd_args;
+	bool print_wmsg;
+
+	argv++;
+	argc--;
+	if (argc < 1) {
 		usage();
 		return -1;
 	}
+
+	if (str_cmp(*argv, "-w") == 0) {
+		print_wmsg = true;
+		argv++;
+		argc--;
+	} else {
+		print_wmsg = false;
+	}
+
+	if (argc < 2) {
+		usage();
+		return -1;
+	}
+
+	term = *argv++;
+	fname = *argv;
+	cmd_args = argv;
 	
-	reopen(&stdin, 0, argv[1], O_RDONLY, "r");
-	reopen(&stdout, 1, argv[1], O_WRONLY, "w");
-	reopen(&stderr, 2, argv[1], O_WRONLY, "w");
+	reopen(&stdin, 0, term, O_RDONLY, "r");
+	reopen(&stdout, 1, term, O_WRONLY, "w");
+	reopen(&stderr, 2, term, O_WRONLY, "w");
 	
 	/*
@@ -114,16 +127,23 @@
 		return -4;
 	
-	version_print(argv[1]);
-	task_id_t id = spawn(argv[2]);
-	
-	if (id != 0) {
-		task_exit_t texit;
-		int retval;
-		task_wait(id, &texit, &retval);
-		
-		return 0;
+	version_print(term);
+	if (print_wmsg)
+		welcome_msg_print();
+
+	rc = task_spawnv(&id, fname, (const char * const *) cmd_args);
+	if (rc != EOK) {
+		printf("%s: Error spawning %s (%s)\n", APP_NAME, fname,
+		    str_error(rc));
+		return -5;
 	}
-	
-	return -5;
+
+	rc = task_wait(id, &texit, &retval);
+	if (rc != EOK) {
+		printf("%s: Error waiting for %s (%s)\n", APP_NAME, fname,
+		    str_error(rc));
+		return -6;
+	}
+
+	return 0;
 }
 
Index: uspace/app/getterm/version.c
===================================================================
--- uspace/app/getterm/version.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/app/getterm/version.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -61,5 +61,5 @@
 	printf("HelenOS release %s (%s)%s%s\n", release, name, revision, timestamp);
 	printf("Running on %s (%s)\n", arch, term);
-	printf("Copyright (c) 2001-2009 HelenOS project\n\n");
+	printf("Copyright (c) 2001-2010 HelenOS project\n\n");
 }
 
Index: uspace/app/getterm/welcome.c
===================================================================
--- uspace/app/getterm/welcome.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
+++ uspace/app/getterm/welcome.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup getterm
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <stdio.h>
+#include "welcome.h"
+
+/** Welcome message and survival tips. */
+void welcome_msg_print(void)
+{
+	printf("Welcome to HelenOS!\n");
+	printf("http://www.helenos.org/\n\n");
+	printf("Type 'help' [Enter] to see a few survival tips.\n\n");
+}
+
+/** @}
+ */
Index: uspace/app/getterm/welcome.h
===================================================================
--- uspace/app/getterm/welcome.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
+++ uspace/app/getterm/welcome.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup getterm
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef WELCOME_H__
+#define WELCOME_H__
+
+extern void welcome_msg_print(void);
+
+#endif
+
+/** @}
+ */
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/app/init/init.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -185,5 +185,5 @@
 	
 	/* Wait for the input device to be ready */
-	dev_handle_t handle;
+	devmap_handle_t handle;
 	rc = devmap_device_get_handle(dev, &handle, IPC_FLAG_BLOCKING);
 	if (rc != EOK) {
@@ -200,5 +200,5 @@
 }
 
-static void getterm(const char *dev, const char *app)
+static void getterm(const char *dev, const char *app, bool wmsg)
 {
 	char term[DEVMAP_NAME_MAXLEN];
@@ -210,5 +210,5 @@
 	
 	/* Wait for the terminal device to be ready */
-	dev_handle_t handle;
+	devmap_handle_t handle;
 	rc = devmap_device_get_handle(dev, &handle, IPC_FLAG_BLOCKING);
 	if (rc != EOK) {
@@ -218,8 +218,18 @@
 	}
 	
-	rc = task_spawnl(NULL, APP_GETTERM, APP_GETTERM, term, app, NULL);
-	if (rc != EOK) {
-		printf("%s: Error spawning %s %s %s (%s)\n", NAME,
-		    APP_GETTERM, term, app, str_error(rc));
+	if (wmsg) {
+		rc = task_spawnl(NULL, APP_GETTERM, APP_GETTERM, "-w", term,
+		    app, NULL);
+		if (rc != EOK) {
+			printf("%s: Error spawning %s -w %s %s (%s)\n", NAME,
+			    APP_GETTERM, term, app, str_error(rc));
+		}
+	} else {
+		rc = task_spawnl(NULL, APP_GETTERM, APP_GETTERM, term, app,
+		    NULL);
+		if (rc != EOK) {
+			printf("%s: Error spawning %s %s %s (%s)\n", NAME,
+			    APP_GETTERM, term, app, str_error(rc));
+		}
 	}
 }
@@ -295,11 +305,11 @@
 #endif
 	
-	getterm("term/vc0", "/app/bdsh");
-	getterm("term/vc1", "/app/bdsh");
-	getterm("term/vc2", "/app/bdsh");
-	getterm("term/vc3", "/app/bdsh");
-	getterm("term/vc4", "/app/bdsh");
-	getterm("term/vc5", "/app/bdsh");
-	getterm("term/vc6", "/app/klog");
+	getterm("term/vc0", "/app/bdsh", true);
+	getterm("term/vc1", "/app/bdsh", false);
+	getterm("term/vc2", "/app/bdsh", false);
+	getterm("term/vc3", "/app/bdsh", false);
+	getterm("term/vc4", "/app/bdsh", false);
+	getterm("term/vc5", "/app/bdsh", false);
+	getterm("term/vc6", "/app/klog", false);
 	
 	return 0;
Index: uspace/app/mkfat/mkfat.c
===================================================================
--- uspace/app/mkfat/mkfat.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/app/mkfat/mkfat.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -85,5 +85,5 @@
     struct fat_params *par);
 static int fat_blocks_write(struct fat_params const *par,
-    dev_handle_t handle);
+    devmap_handle_t handle);
 static void fat_bootsec_create(struct fat_params const *par, struct fat_bs *bs);
 
@@ -95,5 +95,5 @@
 	int rc;
 	char *dev_path;
-	dev_handle_t handle;
+	devmap_handle_t handle;
 	size_t block_size;
 	char *endptr;
@@ -234,5 +234,5 @@
 
 /** Create file system with the given parameters. */
-static int fat_blocks_write(struct fat_params const *par, dev_handle_t handle)
+static int fat_blocks_write(struct fat_params const *par, devmap_handle_t handle)
 {
 	aoff64_t addr;
Index: uspace/app/netecho/netecho.c
===================================================================
--- uspace/app/netecho/netecho.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/app/netecho/netecho.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -173,4 +173,6 @@
 				} else if (str_lcmp(argv[index] + 2, "count=", 6) == 0) {
 					rc = arg_parse_int(argc, argv, &index, &count, 8);
+					if (rc != EOK)
+						return rc;
 				} else if (str_lcmp(argv[index] + 2, "family=", 7) == 0) {
 					rc = arg_parse_name_int(argc, argv, &index, &family, 9, socket_parse_protocol_family);
Index: uspace/app/netstart/Makefile
===================================================================
--- uspace/app/netstart/Makefile	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/app/netstart/Makefile	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -29,6 +29,6 @@
 
 USPACE_PREFIX = ../..
-LIBS = $(LIBNET_PREFIX)/libnet.a
-EXTRA_CFLAGS = -I$(LIBNET_PREFIX)/include
+LIBS = 
+EXTRA_CFLAGS = 
 
 BINARY = netstart
Index: uspace/app/nettest1/nettest1.c
===================================================================
--- uspace/app/nettest1/nettest1.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/app/nettest1/nettest1.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -287,9 +287,6 @@
 int main(int argc, char *argv[])
 {
-
-	socklen_t max_length;
-	uint8_t *address_data[sizeof(struct sockaddr_in6)];
-	struct sockaddr_in *address_in;
-	struct sockaddr_in6 *address_in6;
+	struct sockaddr_in address_in;
+	struct sockaddr_in6 address_in6;
 	uint8_t *address_start;
 
@@ -300,9 +297,4 @@
 
 	int rc;
-
-	max_length = sizeof(address_data);
-	address = (struct sockaddr *) address_data;
-	address_in = (struct sockaddr_in *) address;
-	address_in6 = (struct sockaddr_in6 *) address;
 
 	sockets = 10;
@@ -334,18 +326,19 @@
 
 	/* Prepare the address buffer */
-	bzero(address_data, max_length);
 
 	switch (family) {
 	case PF_INET:
-		address_in->sin_family = AF_INET;
-		address_in->sin_port = htons(port);
-		address_start = (uint8_t *) &address_in->sin_addr.s_addr;
-		addrlen = sizeof(struct sockaddr_in);
+		address_in.sin_family = AF_INET;
+		address_in.sin_port = htons(port);
+		address = (struct sockaddr *) &address_in;
+		addrlen = sizeof(address_in);
+		address_start = (uint8_t *) &address_in.sin_addr.s_addr;
 		break;
 	case PF_INET6:
-		address_in6->sin6_family = AF_INET6;
-		address_in6->sin6_port = htons(port);
-		address_start = (uint8_t *) &address_in6->sin6_addr.s6_addr;
-		addrlen = sizeof(struct sockaddr_in6);
+		address_in6.sin6_family = AF_INET6;
+		address_in6.sin6_port = htons(port);
+		address = (struct sockaddr *) &address_in6;
+		addrlen = sizeof(address_in6);
+		address_start = (uint8_t *) &address_in6.sin6_addr.s6_addr;
 		break;
 	default:
Index: uspace/app/nettest2/nettest2.c
===================================================================
--- uspace/app/nettest2/nettest2.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/app/nettest2/nettest2.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -223,9 +223,7 @@
 int main(int argc, char *argv[])
 {
-	socklen_t max_length;
-	uint8_t address_data[sizeof(struct sockaddr_in6)];
 	struct sockaddr *address;
-	struct sockaddr_in *address_in;
-	struct sockaddr_in6 *address_in6;
+	struct sockaddr_in address_in;
+	struct sockaddr_in6 address_in6;
 	socklen_t addrlen;
 	uint8_t *address_start;
@@ -247,9 +245,4 @@
 	port = 7;
 
-	max_length = sizeof(address_data);
-	address = (struct sockaddr *) address_data;
-	address_in = (struct sockaddr_in *) address;
-	address_in6 = (struct sockaddr_in6 *) address;
-
 	/*
 	 * Parse the command line arguments.
@@ -279,18 +272,19 @@
 
 	/* Prepare the address buffer */
-	bzero(address_data, max_length);
 
 	switch (family) {
 	case PF_INET:
-		address_in->sin_family = AF_INET;
-		address_in->sin_port = htons(port);
-		address_start = (uint8_t *) &address_in->sin_addr.s_addr;
-		addrlen = sizeof(struct sockaddr_in);
+		address_in.sin_family = AF_INET;
+		address_in.sin_port = htons(port);
+		address = (struct sockaddr *) &address_in;
+		addrlen = sizeof(address_in);
+		address_start = (uint8_t *) &address_in.sin_addr.s_addr;
 		break;
 	case PF_INET6:
-		address_in6->sin6_family = AF_INET6;
-		address_in6->sin6_port = htons(port);
-		address_start = (uint8_t *) &address_in6->sin6_addr.s6_addr;
-		addrlen = sizeof(struct sockaddr_in6);
+		address_in6.sin6_family = AF_INET6;
+		address_in6.sin6_port = htons(port);
+		address = (struct sockaddr *) &address_in6;
+		addrlen = sizeof(address_in6);
+		address_start = (uint8_t *) &address_in6.sin6_addr.s6_addr;
 		break;
 	default:
